#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <string>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;
int k = 0;
vector<pair<int, int>> d = { {1, 0}, {0, 1}, {-1, 0}, {0, -1} };
int n, m;
void dfs(int i, int j, const vector<vector<int>>& mp, vector<vector<int>>& rw, int og, bool sc) {
    rw[i][j] = k;
    for (auto w : d) {
        int x = i + w.first;
        int y = j + w.second;
        if (x < 0 || y < 0 || x >= n || y >= m)
            continue;
        if (sc) {
            if (y < og)
                continue;
        }
        else {
            if (y > og)
                continue;
        }
        if (mp[i][j] != mp[x][y])
            continue;
        if (rw[x][y] != -1) {
            // to do -------------------------------------------
            continue;
        }
        dfs(x, y, mp, rw, og, sc);
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    vector<int> dpp(m), dps(m);

    vector<vector<int>> rwp(n, vector<int>(m, -1));

    rwp[0][0] = 0;
    for (int i = 1; i < n; i++)
        if (a[i][0] == a[i - 1][0])
            rwp[i][0] = rwp[i - 1][0];
        else
            rwp[i][0] = rwp[i - 1][0] + 1;
    k = rwp[n - 1][0] + 1;
    dpp[0] = k;
    for (int j = 1; j < m; j++) {
        set<int> cl;
        int p = 0;
        dpp[j] = dpp[j - 1];

        if (a[0][j] == a[0][j - 1])
            cl.insert(rwp[0][j - 1]);
        for (int i = 1; i < n; i++) {
            if (a[i][j] == a[i - 1][j]) {
                if (a[i][j] == a[i][j - 1])
                    cl.insert(rwp[i][j - 1]);
            }
            else {
                dpp[j] -= cl.size() - 1;
                int prz = k;
                if (!cl.empty())
                    prz = (*cl.begin());
                for (int I = p; I < i; I++)
                    rwp[I][j] = prz;
                if (cl.empty())
                    k++;
                cl.clear();
                p = i;

                if (a[i][j] == a[i][j - 1])
                    cl.insert(rwp[i][j - 1]);
            }

        }
        dpp[j] -= cl.size() - 1;
        int prz = k;
        if (!cl.empty())
            prz = (*cl.begin());
        for (int I = p; I < n; I++)
            rwp[I][j] = prz;
        if (cl.empty())
            k++;
        cl.clear();
    }

    k = 0;
    vector<vector<int>> rws(n, vector<int>(m, -1));

    rws[0][m - 1] = 0;
    for (int i = 1; i < n; i++)
        if (a[i][m - 1] == a[i - 1][m - 1])
            rws[i][m - 1] = rws[i - 1][m - 1];
        else
            rws[i][m - 1] = rws[i - 1][m  - 1] + 1;
    k = rws[n - 1][m - 1] + 1;
    dps[m - 1] = k;
    for (int j = m - 2; j >= 0; j--) {
        set<int> cl;
        int p = 0;
        dps[j] = dps[j + 1];
        if (a[0][j] == a[0][j + 1])
            cl.insert(rws[0][j + 1]);
        for (int i = 1; i < n; i++) {
            if (a[i][j] == a[i - 1][j]) {
                if (a[i][j] == a[i][j + 1]) 
                    cl.insert(rws[i][j + 1]);
            }
            else {
                dps[j] -= cl.size() - 1;
                int prz = k;
                if (!cl.empty())
                    prz = (*cl.begin());
                for (int I = p; I < i; I++)
                    rws[I][j] = prz;
                if (cl.empty())
                    k++;
                cl.clear();
                p = i;
                if (a[i][j] == a[i][j + 1])
                    cl.insert(rws[i][j + 1]);
            }
        }
        dps[j] -= cl.size() - 1;
        int prz = k;
        if (!cl.empty())
            prz = (*cl.begin());
        for (int I = p; I < n; I++)
            rws[I][j] = prz;
        if (cl.empty())
            k++;
        cl.clear();
    }

    int ans = n * m;
    for (int j = 1; j < m; j++) 
        ans = min(ans, dpp[j - 1] + dps[j]);
    cout << ans << "\n";
}