#include<bits/stdc++.h>

using namespace std;

const int dim = 1e5+7, dim2 = 1e3+7;

int n, m;
int a[dim][dim2], res1[dim], t[dim][dim2];
int b[dim2][dim], t2[dim2][dim];

void add(int x, int y, int val){
    x++; y++;
    for(int i = x; i<n+100; i+=i&-i){
        for(int j = y; j<m+100; j+=j&-j)t[i][j]+=val;
    }
}

int prefsum(int x, int y){
    x++; y++;
    int sum = 0;
    for(int i = x; i>0; i-=i&-i){
        for(int j = y; j>0; j-=j&-j)sum+=t[i][j];
    }
    return sum;
}

int sum(int x, int y, int a, int b){
    return prefsum(a, b)-prefsum(x-1, b)-prefsum(a, y-1)+prefsum(x-1, y-1);
}

void add2(int x, int y, int val){
    x++; y++;
    for(int i = x; i<n+100; i+=i&-i){
        for(int j = y; j<m+100; j+=j&-j)t2[i][j]+=val;
    }
}

int prefsum2(int x, int y){
    x++; y++;
    int sum = 0;
    for(int i = x; i>0; i-=i&-i){
        for(int j = y; j>0; j-=j&-j)sum+=t2[i][j];
    }
    return sum;
}

int sum2(int x, int y, int a, int b){
    return prefsum2(a, b)-prefsum2(x-1, b)-prefsum2(a, y-1)+prefsum2(x-1, y-1);
}


void solve(int n, int m){

    char c;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            cin >> c;
            if(c=='#')a[i][j] = 1;
            else a[i][j] = 0;
        }
    }
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
                add(i, j, a[i][j]);
        }
    }

    int maxc = 0, maxpos, curmax;
    for(int i = 1; i<=n; i++){
        curmax = 0; maxpos = 1; maxc = 0;
        for(int j = 1; j<=m; j++){
            curmax = max(sum(1, j, i-1, j)+sum(i+1, j, n, j)+(a[i][j]^1), curmax);
            if(curmax>maxc)maxpos = j;
            maxc = max(maxc, curmax);
        }


        res1[i]+= sum(1, 1, i-1, maxpos-1) + sum(1, maxpos+1, i-1, m) +
        sum(i+1, 1, n, maxpos-1) + sum(i+1, maxpos+1, n, m);
        int r = sum(i, 1, i, maxpos-1) + sum(i, maxpos+1, i, m);
        res1[i]+=m-1-r;
        int c = sum(1, maxpos, i-1, maxpos) + sum(i+1, maxpos, n, maxpos);
        res1[i]+=n-1-c;
        res1[i]+=a[i][maxpos];
    }

    int ma = 0;
    for(int i = 1; i<=n; i++)ma = max(ma, res1[i]);
    cout << ma << " " << n*m-ma;
}

void solve2(int n, int m){

    char c;
    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
            cin >> c;
            if(c=='#')b[i][j] = 1;
            else b[i][j] = 0;
        }
    }

    for(int i = 1; i<=n; i++){
        for(int j = 1; j<=m; j++){
                add2(i, j, b[i][j]);
        }
    }

    int maxc = 0, maxpos, curmax;
    for(int i = 1; i<=n; i++){
        curmax = 0; maxpos = 1; maxc = 0;
        for(int j = 1; j<=m; j++){
            curmax = max(sum2(1, j, i-1, j)+sum2(i+1, j, n, j)+(b[i][j]^1), curmax);
            if(curmax>maxc)maxpos = j;
            maxc = max(maxc, curmax);
        }

        res1[i]+= sum2(1, 1, i-1, maxpos-1) + sum2(1, maxpos+1, i-1, m) +
        sum2(i+1, 1, n, maxpos-1) + sum2(i+1, maxpos+1, n, m);
        int r = sum2(i, 1, i, maxpos-1) + sum2(i, maxpos+1, i, m);
        res1[i]+=m-1-r;
        int c = sum2(1, maxpos, i-1, maxpos) + sum2(i+1, maxpos, n, maxpos);
        res1[i]+=n-1-c;
        res1[i]+=b[i][maxpos];
    }

    int ma = 0;
    for(int i = 1; i<=n; i++)ma = max(ma, res1[i]);
    cout << ma << " " << n*m-ma;
}

int main(){

    cin >> n >> m;
    if(n>m)solve(n, m);
    else solve2(n, m);

    return 0;
}
