#include <iostream>
#include <vector>

using namespace std;

int main() {
    int height, width;
    cin >> height >> width;

    int* row_counts = new int[height];
    int* column_counts = new int[width];

    int alice_count = 0;
    int bob_count = 0;

    int max_alice_addition = 0;
    int max_bob_addition = 0;
    int alice_taken_row_index = 0;
    string alice_taken_row;

    memset(row_counts, 0, height * sizeof(int));
    memset(column_counts, 0, width * sizeof(int));

    for (int y = 0; y < height; y++) {
        string row;
        cin >> row;

        for (int x = 0; x < width; x++) {
            char c = row[x];

            if (c == '.') {
                bob_count += 1;
                row_counts[y] += 1;

                if (row_counts[y] > max_alice_addition) {
                    max_alice_addition = row_counts[y];
                    alice_taken_row_index = y;
                    alice_taken_row = row;
                }
            } else {
                alice_count += 1;
                column_counts[x] += 1;
            }
        }
    }

    int alice_delta = 0;

    for (int x = 0; x < width; x++) {
        if (alice_taken_row[x] == '.') {
            column_counts[x] += 1;
        } else {
            column_counts[x] -= 1;
        }

        if (column_counts[x] > max_bob_addition) {
            max_bob_addition = column_counts[x];

            alice_delta = alice_taken_row[x] == '.' ? -1 : 1;
        }
    }

    max_alice_addition += alice_delta;

    alice_count = alice_count + max_alice_addition - max_bob_addition;
    bob_count = bob_count + max_bob_addition - max_alice_addition;

    cout << alice_count << " " << bob_count << "\n";

    return 0;
}
