#include <bits/stdc++.h>
typedef long double ld;
typedef long long ll;
using namespace std;
ll n, m;
bool can(ll first, ll second){
    if(first>=0 && second>=0 && first<n && second<m) return true;
    else return false;
}
int main(){
    ios::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin >> n >> m;
    ll table[n][m];
    ll visited[n][m];
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            cin >> table[i][j];
            visited[i][j]=0;
        }
    }
    ll indx = 1;
    ll count = 0;
    for(ll i = 0; i<n; i++){
        for(ll j = 0; j<m; j++){
            if(!visited[i][j]){
                visited[i][j]=indx;
                queue<pair<ll, ll>> q;
                ll v = table[i][j];
                q.push({i, j});
                while(!q.empty()){
                    pair<ll, ll> now = q.front();
                    q.pop();
                    if(can(now.first+1, now.second) && !visited[now.first+1][now.second] && table[now.first+1][now.second]==v){
                        visited[now.first+1][now.second]=indx;
                        q.push({now.first+1, now.second});
                    }
                    if(can(now.first-1, now.second) && !visited[now.first-1][now.second] && table[now.first-1][now.second]==v){
                        visited[now.first-1][now.second]=indx;
                        q.push({now.first-1, now.second});
                    }
                    if(can(now.first, now.second+1) && !visited[now.first][now.second+1] && table[now.first][now.second+1]==v){
                        visited[now.first][now.second+1]=indx;
                        q.push({now.first, now.second+1});
                    }
                    if(can(now.first, now.second-1) && !visited[now.first][now.second-1] && table[now.first][now.second-1]==v){
                        visited[now.first][now.second-1]=indx;
                        q.push({now.first, now.second-1});
                    }
                }
                indx++;
            }
        }
    }
    ll minimum = 1000000000000000000;
    for(ll i = 0; i<m-1; i++){
        ll now = indx-1;
        ll last = -1;
        for(ll j = 0; j<n; j++){
            if(visited[j][i]==visited[j][i+1] && visited[j][i+1]!=last){
                now++;
                last=visited[j][i];
            }
        }
        minimum=min(minimum, now);
    }
    cout << minimum;
}