#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = int;

ll a[250000];

ll binsearch(ll b, ll n) {
	ll l = 0, r = n - 1, m;
	while (l < r - 1) {
		m = l + (r - l) / 2;
		if (a[m] > b) {
			r = m;
		}
		else if(a[m] < b) {
			l = m;
		}
		else {
			return m;
		}
	}
	return l;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);cout.tie(0);
	ll n, m, k, inp = 0, coord;
	cin >> n >> m >> k;
	for (ll i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (ll i = 0; i < m; i++) {
		cin >> inp;
		coord = binsearch(inp, n);
		if (coord == n - 1) {
			if (k - abs(a[coord] - inp) < 0) {
				cout << 0 << '\n';
			}
			else {
				cout << k - abs(a[coord] - inp) << '\n';
			}
		}
		else {
			if (k - min(abs(a[coord] - inp), abs(a[coord + 1] - inp)) < 0) {
				cout << 0 << '\n';
			}
			else {
				cout << k - min(abs(a[coord] - inp), abs(a[coord + 1] - inp)) << '\n';
			}
		}
	}
}