#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct node {
  ll row;
  ll col;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, l, r, mx, mn, sm;
  bool bl;
  string str;
  char ch;
  ll h, w;
  cin >> h >> w;
  char arr[h][w];
  pair<ll, ll> rows[h];
  pair<ll, ll> cols[w];
  ll mx_index = 0;
  for (ll i = 0; i < h; i++) {
    for (ll j = 0; j < w; j++) {
      cin >> arr[i][j];
      if (arr[i][j] == '#') {
        rows[i].first++;
        cols[j].first++;
      } else {
        rows[i].second++;
        cols[j].second++;
        if (rows[mx_index].second < rows[i].second) {
          mx_index = i;
        }
      }
    }
  }
  swap(rows[mx_index].first, rows[mx_index].second);
  ll mx_index_2 = 0;
  for (ll j = 0; j < w; j++) {
    if (arr[mx_index][j] == '#') {
      cols[j].first--;
      cols[j].second++;
    } else {
      cols[j].second--;
      cols[j].first++;
    }
    if (cols[mx_index_2].first < cols[j].first) {
      mx_index_2 = j;
    }
  }
  swap(cols[mx_index_2].first, cols[mx_index_2].second);
  a = 0;
  b = 0;
  for (ll j = 0; j < w; j++) {
    a += cols[j].first;
    b += cols[j].second;
  }
  cout << a << " " << b;
}
