#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct node {
  ll row;
  ll col;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, l, r, mx, mn, sm;
  bool bl;
  string str;
  char ch;
  ll h, w;
  cin >> h >> w;
  char arr[h][w];
  vector<ll> cols(w, 0);
  vector<ll> rows(h, 0);
  ll coins = h * w;
  ll tails = 0;
  for (ll i = 0; i < h; i++) {
    for (ll j = 0; j < w; j++) {
      cin >> arr[i][j];
      if (arr[i][j] == '#') {
        rows[i]++;
        cols[j]++;
      } else {
        tails++;
      }
    }
  }
  ll best_bob_move, current_bob_move;
  vector<ll> alice_move_scores(h);
  ll mx_index = 0;
  for (ll i = 0; i < h; i++) {
    best_bob_move = 0;
    for (ll j = 0; j < w; j++) {
      current_bob_move =
          tails - (w - rows[i]) + rows[i] - (h - cols[j]) + cols[j];
      if (arr[i][j] == '#') {
        current_bob_move -= 2;
      } else {
        current_bob_move += 2;
      }
      best_bob_move = max(best_bob_move, current_bob_move);
    }
    alice_move_scores[i] = coins - best_bob_move;
    if (alice_move_scores[i] > alice_move_scores[mx_index]) {
      mx_index = i;
    }
  }
  cout << alice_move_scores[mx_index] << " "
       << coins - alice_move_scores[mx_index];
}
