#include <algorithm>
#include <climits>
#include <cmath>
#include <cstring>
#include <iostream>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define nl "\n"
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()

struct node {
  ll row;
  ll col;
};

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  // freopen("in", "r", stdin);
  ll n, m, k;
  ll a, b, c, d, e, f, g, l, r, mx, mn, sm;
  bool bl;
  string str;
  char ch;
  ll h, w;
  cin >> h >> w;
  ll arr[h][w];
  for (ll i = 0; i < h; i++) {
    for (ll j = 0; j < w; j++) {
      cin >> arr[i][j];
    }
  }
  if (h > 2) {
    bool visited[h][w];
    ll answer = LLONG_MAX;
    for (ll k = 0; k < w - 1; k++) {
      memset(visited, false, h * w);
      ll groups = 0;
      queue<node> bfs;
      for (ll i = 0; i < h; i++) {
        for (ll j = 0; j < w; j++) {
          if (!visited[i][j]) {
            groups++;
            bfs.push({i, j});
            while (!bfs.empty()) {
              node current = bfs.front();
              bfs.pop();
              if (visited[current.row][current.col])
                continue;
              visited[current.row][current.col] = true;
              if (current.row > 0 && arr[current.row - 1][current.col] ==
                                         arr[current.row][current.col]) {
                bfs.push({current.row - 1, current.col});
              }
              if (current.row < h - 1 && arr[current.row + 1][current.col] ==
                                             arr[current.row][current.col]) {
                bfs.push({current.row + 1, current.col});
              }
              if (current.col > 0 &&
                  arr[current.row][current.col - 1] ==
                      arr[current.row][current.col] &&
                  k != current.col - 1) {
                bfs.push({current.row, current.col - 1});
              }
              if (current.col < w - 1 &&
                  arr[current.row][current.col + 1] ==
                      arr[current.row][current.col] &&
                  k != current.col) {
                bfs.push({current.row, current.col + 1});
              }
            }
          }
        }
      }
      answer = min(answer, groups);
    }
    cout << answer;
  } else {
    vector<ll> connection_count(w - 1, 0);
    ll connections_sum = 0;
    ll group_count = w;
    for (ll j = 0; j < w - 1; j++) {
      for (ll i = 0; i < h; i++) {
        if (arr[i][j] == arr[i][j + 1]) {
          connection_count[j]++;
          connections_sum++;
          if (i > 0 && arr[i][j] == arr[i - 1][j] &&
              arr[i][j + 1] == arr[i - 1][j + 1]) {
            connection_count[j]--;
            connections_sum--;
          }
        }
        if (i > 0 && arr[i][j] != arr[i - 1][j]) {
          group_count++;
        }
      }
    }
    for (ll i = 1; i < h; i++) {
      if (arr[i][w - 1] != arr[i - 1][w - 1]) {
        group_count++;
      }
    }
    mn = LLONG_MAX;
    if (w == 1)
      mn = 0;
    else {
      for (ll i : connection_count) {
        mn = min(mn, i);
      }
    }
    cout << group_count - connections_sum + mn;
  }
}
