#include <bits/stdc++.h>

using namespace std;

long long h, w;
vector<long long> v[500005], inc, used1[500005];
vector<bool> us1, us2;

long long flood(long long x, long long y, long long num, long long stnum, long long iter, long long w1)
{
    if(x<0||y<0||x>=h||y>w1||used1[x][y]==iter||v[x][y]!=stnum)
        return -500005;

    used1[x][y]=iter;

    if(num!=-1)
        v[x][y]=num;

    long long p1, p2, p3, p4;

    p1=flood(x+1, y, num, stnum, iter, w1);
    p2=flood(x-1, y, num, stnum, iter, w1);
    p3=flood(x, y+1, num, stnum, iter, w1);
    p4=flood(x, y-1, num, stnum, iter, w1);

    return max(y, max(max(p1, p2), max(p3, p4)));
}

long long floodcheck(long long iter)
{
    long long nc=0;

    for(auto i=0; i<h; i++)
        for(auto j=0; j<=w; j++)
            if(v[i][j]!=-1&&used1[i][j]!=iter)
            {
                long long fl=flood(i, j, -1, v[i][j], iter, w);
                nc++;
            }

    return nc;
}

long long longcheck()
{
    long long mink=5000005;

    for(auto i=0; i<w-1; i++)
    {
        for(auto j=0; j<h; j++)
            v[j].insert(v[j].begin()+i+1, -1);

        long long tmk=floodcheck(i);
        mink=min(mink, tmk);

        for(auto j=0; j<h; j++)
            v[j].erase(v[j].begin()+i+1);
    }

    return mink;
}

long long shortcheck()
{
    long long nc=0, mink=5000005;

    for(auto i=0; i<h; i++)
        for(auto j=0; j<w; j++)
            if(used1[i][j]==-1)
            {
                long long fl=flood(i, j, nc, v[i][j], 0, w-1);
                nc++;
                inc.push_back(fl);
                us1.push_back(0);
            }

    for(auto i=0; i<w-1; i++)
    {
        long long tmik=0;
        us2=us1;

        for(auto j=0; j<h; j++)
        {
            if(!us2[v[j][i]]&&inc[v[j][i]]>i)
            {
                us2[v[j][i]]=1;
                tmik++;
            }
        }

        mink=min(mink, tmik);
    }

    return nc+mink;
}

int main()
{
    cin>>h>>w;

    for(auto i=0; i<h; i++)
        for(auto j=0; j<w; j++)
        {
            long long x;
            cin>>x;

            v[i].push_back(x);
            used1[i].push_back(-1);
        }

    for(auto i=0; i<h; i++)
        used1[i].push_back(-1);

    if(h<=2||h>200)
        cout<<shortcheck();
    else
        cout<<longcheck();

    return 0;
}
